-module(mist@file).
-compile([no_auto_import, nowarn_unused_vars]).

-export([size/1, open/1]).
-export_type([file_error/0]).

-type file_error() :: is_dir | no_access | no_entry | unknown_file_error.

-spec size(bitstring()) -> integer().
size(Path) ->
    filelib:file_size(Path).

-spec open(bitstring()) -> {ok, mist@internal@file:file_descriptor()} |
    {error, file_error()}.
open(File) ->
    mist_ffi:file_open(File).
